#include "StdAfx.h"
#include ".\cryptopploop.h"
#include "..\..\crypto51\rsa.h"
#include "..\..\crypto51\ripemd.h"
#include <string>
#include <map>

CryptoppLoop::CryptoppLoop(void)
{
}

CryptoppLoop::~CryptoppLoop(void)
{
}

bool CryptoppLoop::TestSigning()
{
   std::string modulusString         = "FB7BCBA59CB0759AE22CB58AD27A8C902344E17D9D373B387650D77F9BA0F21C3821F089FC450AC6CB7D71A6C6FF7F3572D7597123BA1DFD46502EA31E09037A81AA09C19BE7967FB99F414FF1156EC8A40BDE3E76D66230072951D380EA91013D90A21D486C7DB5815DF9F71B379C8EF70CE6D763262B766522B74D97147CB2";
   std::string privateExponentString = "711F3E535464C57184A81291A44D6CD4BA3065E650662FF3CD01C8D1DF85E6180AEB07D38F5FEC85AEF7F33D18A3F19D901C68CBECE24E07C9987CC2BC6D4CAB343C899A3983FC8EF3DF5668FD21C88C95898174ABF89817D49D59348F56B069B055C28CDFD6CAE316A7D13A50A02A19954DDDE95C9D07426C602F86ED4E7F1F";
   unsigned long pubExponent = 17;
   std::vector<BYTE> modulusVector = this->HexToByte(modulusString);
   std::vector<BYTE> privateExponentVector = this->HexToByte(privateExponentString);
   
   CryptoPP::Integer publicExponent(pubExponent);
   CryptoPP::Integer modulus(VectorToInteger(modulusVector));
   CryptoPP::Integer privateExponent(VectorToInteger(privateExponentVector));


   CryptoPP::InvertibleRSAFunction libRSAKey;
   libRSAKey.Initialize(privateExponent, publicExponent, modulus);
   CryptoPP::RSASS<CryptoPP::PKCS1v15, CryptoPP::RIPEMD160>::Signer* libRSASigner = new CryptoPP::RSASS<CryptoPP::PKCS1v15, CryptoPP::RIPEMD160>::Signer(libRSAKey);
   return false;
}

CryptoPP::Integer CryptoppLoop::VectorToInteger(const std::vector<BYTE> &vbData)
{
   BYTE* abData = new BYTE[vbData.size()];
   for (unsigned long i=0; i<vbData.size(); i++)
   {
      abData[i] = vbData[i];
   }
   return CryptoPP::Integer(abData, vbData.size());
}

std::vector<BYTE> CryptoppLoop::HexToByte(std::string &stData)
{
   std::map<char, BYTE> hexmap;
   hexmap['0'] = (BYTE) 0x0;
   hexmap['1'] = (BYTE) 0x1;
   hexmap['2'] = (BYTE) 0x2;
   hexmap['3'] = (BYTE) 0x3;
   hexmap['4'] = (BYTE) 0x4;
   hexmap['5'] = (BYTE) 0x5;
   hexmap['6'] = (BYTE) 0x6;
   hexmap['7'] = (BYTE) 0x7;
   hexmap['8'] = (BYTE) 0x8;
   hexmap['9'] = (BYTE) 0x9;
   hexmap['A'] = (BYTE) 0xA;
   hexmap['B'] = (BYTE) 0xB;
   hexmap['C'] = (BYTE) 0xC;
   hexmap['D'] = (BYTE) 0xD;
   hexmap['E'] = (BYTE) 0xE;
   hexmap['F'] = (BYTE) 0xF;

   std::vector<BYTE> vbData;

   unsigned long i;
   if (stData.size()%2 != 0)
   {
      vbData.push_back(hexmap[stData.at(0)]);
      i=1;
   }
   else
   {
      i=0;
   }
   BYTE temp;
   for (; i<stData.size(); i+=2)
   {
      temp = hexmap[stData.at(i)];
      temp *= 16;
      temp += hexmap[stData.at(i+1)];
      vbData.push_back(temp);
   }
   return vbData;
}

